unit Options;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,
  Global;

type
  TOptionsDlg = class(TForm)
    DisplayMode: TRadioGroup;
    DisplaySpeed: TRadioGroup;
    DetailLvl: TScrollBar;
    DetailLbl: TLabel;
    RedrawBtn: TButton;
    RegenBtn: TButton;
    CloseBtn: TButton;
    procedure FormShow(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure RedrawBtnClick(Sender: TObject);
    procedure RegenBtnClick(Sender: TObject);
    procedure DisplayModeClick(Sender: TObject);
    procedure DisplaySpeedClick(Sender: TObject);
    procedure DetailLvlChange(Sender: TObject);
  private
    { Private declarations }
    ProgramUpdate: boolean;
  public
    { Public declarations }
    procedure Update(DrawMode: DrawModes; DrawRate: DrawRates; Plys: integer);
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

uses Main;

{$R *.DFM}

procedure TOptionsDlg.FormShow(Sender: TObject);
begin
  Update(DrawMode, DrawRate, Plys);
end;

procedure TOptionsDlg.Update( DrawMode: DrawModes;
                              DrawRate: DrawRates;
                              Plys:     integer);
begin
  ProgramUpdate := True;
    DisplayMode.ItemIndex  := ord(DrawMode);
    DisplaySpeed.ItemIndex := ord(DrawRate);
    DetailLvl.Position     := Plys;
  ProgramUpdate := False;
end;

procedure TOptionsDlg.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsDlg.RedrawBtnClick(Sender: TObject);
begin
  FractalLandscape.ShowLandscape;
end;

procedure TOptionsDlg.RegenBtnClick(Sender: TObject);
begin
  FractalLandscape.GenerateLandscape;
  FractalLandscape.ShowLandscape;
end;

procedure TOptionsDlg.DisplayModeClick(Sender: TObject);
begin
  if not ProgramUpdate then
    FractalLandscape.SetDrawMode(DrawModes( DisplayMode.ItemIndex ));
end;

procedure TOptionsDlg.DisplaySpeedClick(Sender: TObject);
begin
  if not ProgramUpdate then DrawRate := DrawRates ( DisplaySpeed.ItemIndex );
end;

procedure TOptionsDlg.DetailLvlChange(Sender: TObject);
begin
  if not ProgramUpdate then Plys := DetailLvl.Position;
end;

end.
