unit Pentium; {Copyright  1996, Jon Shemitz}

interface

function RDTSC: comp;

type
  CompStr = string[25]; {Comps have up to 18 digits, plus commas, and sign}

function CompToStr(N: comp): CompStr;

implementation

uses SysUtils;

const
  D32 = $66;

function RDTSC: comp;
var
  TimeStamp: record
             case byte of
               1: (Whole:  comp);
               2: (Lo, Hi: LongInt);
             end;
begin
  asm
	db $0F; db $31;	{Pentium RDTSC - Read Time Stamp Counter - instruction}
	db D32
	mov	word ptr TimeStamp.Lo,AX {Write the low dword}
	db D32
	mov	word ptr TimeStamp.Hi,DX {Write the high dword}
  end;
  Result := TimeStamp.Whole;
end;

function CompToStr(N: comp): CompStr;
var
  Low3: string[3];
  N1:   extended;
begin   
  if N < 0
    then Result := '-' + CompToStr(-N)
    else begin
         N1 := N / 1000;
         Str(Round(Frac(N1) * 1000), Low3);
         N := Int(N1);
         if N > 0
           then Result := CompToStr(N) + ThousandSeparator + Low3
           else Result := Low3
         end;
end;

end.
